Index: src/backend/commands/trigger.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/trigger.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/commands/trigger.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/commands/trigger.c	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 1690,1696 ****
--- 1690,1701 ----
  	HeapTuple	newtuple = trigtuple;
  	HeapTuple	oldtuple;
  	TriggerData LocTriggerData;
+ 	TriggerData backupLocTriggerData;
+ 	int			backuptgindx;
  	int			i;
+ 	bool		isPartitionTrigger;
+ 
+ 	isPartitionTrigger = false;
  
  	LocTriggerData.type = T_TriggerData;
  	LocTriggerData.tg_event = TRIGGER_EVENT_INSERT |
***************
*** 1718,1723 ****
--- 1723,1739 ----
  		LocTriggerData.tg_trigtuple = oldtuple = newtuple;
  		LocTriggerData.tg_trigtuplebuf = InvalidBuffer;
  		LocTriggerData.tg_trigger = trigger;
+ 		/* If partition trigger then execute later. */
+ 		if((0 == strncmp(trigger->tgname, "partition_insert_", 17)) || (0 == strncmp(trigger->tgname, "partition_constraints_", 22)))
+ 		{
+ 			if(ntrigs > 1)
+ 			{
+ 				backupLocTriggerData = LocTriggerData;
+ 				backuptgindx =  tgindx[i];
+ 				isPartitionTrigger = true;
+ 				continue;
+ 			}
+ 		}
  		newtuple = ExecCallTriggerFunc(&LocTriggerData,
  									   tgindx[i],
  									   relinfo->ri_TrigFunctions,
***************
*** 1727,1733 ****
--- 1743,1764 ----
  			heap_freetuple(oldtuple);
  		if (newtuple == NULL)
  			break;
+ 		/* Break free from the loop is found dummy-tuple. */
+ 		if (newtuple->t_len == -1)
+ 			break;
  	}
+ 
+ 	if(isPartitionTrigger == true)
+ 	{
+ 		newtuple = ExecCallTriggerFunc(&backupLocTriggerData,
+ 									   backuptgindx,
+ 									   relinfo->ri_TrigFunctions,
+ 									   relinfo->ri_TrigInstrument,
+ 									   GetPerTupleMemoryContext(estate));
+ 		if (oldtuple != newtuple && oldtuple != trigtuple)
+ 			heap_freetuple(oldtuple);
+ 	}
+ 
  	return newtuple;
  }
  
***************
*** 1972,1977 ****
--- 2003,2013 ----
  	HeapTuple	intuple = newtuple;
  	TupleTableSlot *newSlot;
  	int			i;
+ 	TriggerData backupLocTriggerData;
+ 	int			backuptgindx;
+ 	bool		isPartitionTrigger;
+ 
+ 	isPartitionTrigger = false;
  
  	trigtuple = GetTupleForTrigger(estate, relinfo, tupleid, &newSlot);
  	if (trigtuple == NULL)
***************
*** 2010,2015 ****
--- 2046,2062 ----
  		LocTriggerData.tg_trigtuplebuf = InvalidBuffer;
  		LocTriggerData.tg_newtuplebuf = InvalidBuffer;
  		LocTriggerData.tg_trigger = trigger;
+ 		/* If partition trigger then execute later. */
+ 		if(0 == strncmp(trigger->tgname, "partition_update_", 17))
+ 		{
+ 			if(ntrigs > 1)
+ 			{
+ 				backupLocTriggerData = LocTriggerData;
+ 				backuptgindx =  tgindx[i];
+ 				isPartitionTrigger = true;
+ 				continue;
+ 			}
+ 		}
  		newtuple = ExecCallTriggerFunc(&LocTriggerData,
  									   tgindx[i],
  									   relinfo->ri_TrigFunctions,
***************
*** 2019,2025 ****
--- 2066,2090 ----
  			heap_freetuple(oldtuple);
  		if (newtuple == NULL)
  			break;
+ 		/* Break free from the loop if found dummy-tuple. */
+ 		if (newtuple->t_len == -1)
+ 			break;
+ 	}
+ 
+ 	if(isPartitionTrigger == true)
+ 	{
+ 		backupLocTriggerData.tg_trigtuple = trigtuple;
+ 		backupLocTriggerData.tg_newtuple = oldtuple = newtuple;
+ 
+ 		newtuple = ExecCallTriggerFunc(&backupLocTriggerData,
+ 									   backuptgindx,
+ 									   relinfo->ri_TrigFunctions,
+ 									   relinfo->ri_TrigInstrument,
+ 									   GetPerTupleMemoryContext(estate));
+ 		if (oldtuple != newtuple && oldtuple != trigtuple)
+ 			heap_freetuple(oldtuple);
  	}
+ 
  	heap_freetuple(trigtuple);
  	return newtuple;
  }
Index: src/backend/commands/vacuum.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/vacuum.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/commands/vacuum.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/commands/vacuum.c	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 254,259 ****
--- 254,260 ----
  static int	vac_cmp_vtlinks(const void *left, const void *right);
  static bool enough_space(VacPage vacpage, Size len);
  static Size PageGetFreeSpaceWithFillFactor(Relation relation, Page page);
+ List* GetPartitions(Oid parentOid);
  
  
  /****************************************************************************
***************
*** 540,545 ****
--- 541,550 ----
  	if (OidIsValid(relid))
  	{
  		oldcontext = MemoryContextSwitchTo(vac_context);
+ 
+ 		/* Get partitions if any. */
+ 		oid_list = GetPartitions(relid);
+ 
  		oid_list = lappend_oid(oid_list, relid);
  		MemoryContextSwitchTo(oldcontext);
  	}
***************
*** 549,554 ****
--- 554,562 ----
  		Oid			relid;
  
  		relid = RangeVarGetRelid(vacrel, false);
+ 
+ 		/* Get partitions if any. */
+ 		oid_list = GetPartitions(relid);
  
  		/* Make a relation list entry for this guy */
  		oldcontext = MemoryContextSwitchTo(vac_context);
Index: src/backend/executor/execMain.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/executor/execMain.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/executor/execMain.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/executor/execMain.c	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 294,299 ****
--- 294,301 ----
  	 * startup tuple receiver, if we will be emitting tuples
  	 */
  	estate->es_processed = 0;
+ 	estate->es_partition_overflow_tuples = 0;
+ 
  	estate->es_lastoid = InvalidOid;
  
  	sendTuples = (operation == CMD_SELECT ||
***************
*** 1792,1797 ****
--- 1794,1817 ----
  		if (newtuple == NULL)	/* "do nothing" */
  			return;
  
+ 		/* Check for dummy tuple */
+ 		if(newtuple->t_len == -1)
+ 		{
+ 			/* Increase the count of processed rows. */
+ 			(estate->es_processed)++;
+ 			return;
+ 		}
+ 
+ 		/* Check for overflow partition tuple */
+ 		if(newtuple->t_len == -2)
+ 		{
+ 			/* Increase the count of processed rows. */
+ 			(estate->es_processed)++;
+ 			/* Increase the count of overflow partition tuples. */
+ 			(estate->es_partition_overflow_tuples)++;
+ 			return;
+ 		}
+ 
  		if (newtuple != tuple)	/* modified by Trigger(s) */
  		{
  			/*
***************
*** 2029,2034 ****
--- 2049,2074 ----
  
  		if (newtuple == NULL)	/* "do nothing" */
  			return;
+ 
+ 		/* Check for dummy tuple */
+ 		if(newtuple->t_len == -1)
+ 		{
+ 			/* Increase the count of processed rows. */
+ 			(estate->es_processed)++;
+ 			heap_freetuple(newtuple);
+ 			return;
+ 		}
+ 
+ 		/* Check for overflow partition tuple */
+ 		if(newtuple->t_len == -2)
+ 		{
+ 			/* Increase the count of processed rows. */
+ 			(estate->es_processed)++;
+ 			/* Increase the count of overflow partition tuples. */
+ 			(estate->es_partition_overflow_tuples)++;
+ 			heap_freetuple(newtuple);
+ 			return;
+ 		}
  
  		if (newtuple != tuple)	/* modified by Trigger(s) */
  		{
Index: src/backend/executor/execUtils.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/executor/execUtils.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/executor/execUtils.c	19 May 2009 06:59:32 -0000	1.1.1.2
--- src/backend/executor/execUtils.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 200,205 ****
--- 200,207 ----
  	estate->es_tupleTable = NULL;
  
  	estate->es_processed = 0;
+ 	estate->es_partition_overflow_tuples = 0;	
+ 
  	estate->es_lastoid = InvalidOid;
  	estate->es_rowMarks = NIL;
  
Index: src/backend/nodes/copyfuncs.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/nodes/copyfuncs.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/nodes/copyfuncs.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/nodes/copyfuncs.c	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 1566,1571 ****
--- 1566,1657 ----
  	return newnode;
  }
  
+ /*
+  * _copyPartitionAttrs
+  */
+ static PartitionAttrs *
+ _copyPartitionAttrs(PartitionAttrs *from)
+ {
+ 	PartitionAttrs *newnode = makeNode(PartitionAttrs);
+ 
+ 	COPY_SCALAR_FIELD(numberOfPartitions);
+ 	COPY_NODE_FIELD(partitions);
+ 	COPY_SCALAR_FIELD(partFunc);
+ 	COPY_NODE_FIELD(colName);
+ 	COPY_SCALAR_FIELD(hasOverflowPartition);
+ 
+ 	return newnode;
+ }
+ 
+ /*
+  * _copyPartition
+  */
+ static Partition *
+ _copyPartition(Partition *from)
+ {
+ 	Partition *newnode = makeNode(Partition);
+ 
+ 	COPY_NODE_FIELD(partName);
+ 	COPY_NODE_FIELD(partitionCheck);
+ 	COPY_STRING_FIELD(tablespacename);
+ 
+ 	return newnode;
+ }
+ 
+ /*
+  * _copyPartition
+  */
+ static UpdatePartitionStmt *
+ _copyUpdatePartitionStmt(UpdatePartitionStmt *from)
+ {
+ 	UpdatePartitionStmt *newnode = makeNode(UpdatePartitionStmt);
+ 
+ 	COPY_NODE_FIELD(prev);
+ 	COPY_NODE_FIELD(after);
+ 
+ 	return newnode;
+ }
+ 
+ static SplitPartitionStmt * 
+ _copySplitPartitionStmt(SplitPartitionStmt *from)
+ {
+ 	SplitPartitionStmt *newnode = makeNode(SplitPartitionStmt);
+ 
+ 	COPY_NODE_FIELD(partNames);
+ 	COPY_NODE_FIELD(splitValues);
+ 
+ 	return newnode;
+ }
+ 
+ static ExchangePartitionStmt * 
+ _copyExchangePartitionStmt(ExchangePartitionStmt *from)
+ {
+ 	ExchangePartitionStmt *newnode = makeNode(ExchangePartitionStmt);
+ 
+ 	COPY_NODE_FIELD(partNames);
+ 
+ 	return newnode;
+ }
+ 
+ static RenamePartitionStmt * 
+ _copyRenamePartitionStmt(RenamePartitionStmt *from)
+ {
+ 	RenamePartitionStmt *newnode = makeNode(RenamePartitionStmt);
+ 
+ 	COPY_NODE_FIELD(partNames);
+ 
+ 	return newnode;
+ }
+ 
+ static MergePartitionStmt * 
+ _copyMergePartitionStmt(MergePartitionStmt *from)
+ {
+ 	MergePartitionStmt *newnode = makeNode(MergePartitionStmt);
+ 
+ 	COPY_NODE_FIELD(partNames);
+ 
+ 	return newnode;
+ }
  /* ****************************************************************
   *						relation.h copy functions
   *
***************
*** 2091,2096 ****
--- 2177,2185 ----
  	COPY_NODE_FIELD(keys);
  	COPY_NODE_FIELD(options);
  	COPY_STRING_FIELD(indexspace);
+ 	COPY_NODE_FIELD(min_value);
+ 	COPY_NODE_FIELD(max_value);
+ 	COPY_NODE_FIELD(partition_list_values);
  
  	return newnode;
  }
***************
*** 2414,2419 ****
--- 2503,2509 ----
  	COPY_NODE_FIELD(options);
  	COPY_SCALAR_FIELD(oncommit);
  	COPY_STRING_FIELD(tablespacename);
+ 	COPY_NODE_FIELD(partAttr);
  
  	return newnode;
  }
***************
*** 3670,3676 ****
  		case T_FromExpr:
  			retval = _copyFromExpr(from);
  			break;
! 
  			/*
  			 * RELATION NODES
  			 */
--- 3760,3786 ----
  		case T_FromExpr:
  			retval = _copyFromExpr(from);
  			break;
! 		case T_PartitionAttrs:
! 			retval = _copyPartitionAttrs(from);
! 			break;
! 		case T_Partition:
! 			retval = _copyPartition(from);
! 			break;
! 		case T_UpdatePartitionStmt:
! 			retval = _copyUpdatePartitionStmt(from);
! 			break;
! 		case T_SplitPartitionStmt:
! 			retval = _copySplitPartitionStmt(from);
! 			break;
! 		case T_MergePartitionStmt:
! 			retval = _copyMergePartitionStmt(from);
! 			break;
! 		case T_ExchangePartitionStmt:
! 			retval = _copyExchangePartitionStmt(from);
! 			break;
! 		case T_RenamePartitionStmt:
! 			retval = _copyRenamePartitionStmt(from);
! 			break;
  			/*
  			 * RELATION NODES
  			 */
Index: src/backend/nodes/equalfuncs.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/nodes/equalfuncs.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/nodes/equalfuncs.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/nodes/equalfuncs.c	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 721,726 ****
--- 721,747 ----
  	return true;
  }
  
+ static bool 
+ _equalPartitionAttrs(PartitionAttrs *a, PartitionAttrs *b)
+ {
+ 	COMPARE_SCALAR_FIELD(numberOfPartitions);
+ 	COMPARE_NODE_FIELD(partitions);
+ 	COMPARE_SCALAR_FIELD(partFunc);
+ 	COMPARE_NODE_FIELD(colName);
+ 	COMPARE_SCALAR_FIELD(hasOverflowPartition);
+ 
+ 	return true;
+ }
+ 
+ static bool 
+ _equalPartition(Partition *a, Partition *b)
+ {
+ 	COMPARE_NODE_FIELD(partName);
+ 	COMPARE_NODE_FIELD(partitionCheck);
+ 
+ 	return true;
+ }
+ 
  
  /*
   * Stuff from relation.h
***************
*** 1078,1083 ****
--- 1099,1105 ----
  	COMPARE_NODE_FIELD(options);
  	COMPARE_SCALAR_FIELD(oncommit);
  	COMPARE_STRING_FIELD(tablespacename);
+ 	COMPARE_NODE_FIELD(partAttr);
  
  	return true;
  }
***************
*** 2460,2465 ****
--- 2482,2493 ----
  			break;
  		case T_JoinExpr:
  			retval = _equalJoinExpr(a, b);
+ 			break;
+ 		case T_PartitionAttrs:
+ 			retval = _equalPartitionAttrs(a, b);
+ 			break;
+ 		case T_Partition:
+ 			retval = _equalPartition(a, b);
  			break;
  
  			/*
Index: src/backend/optimizer/plan/planner.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/optimizer/plan/planner.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/optimizer/plan/planner.c	19 May 2009 06:59:32 -0000	1.1.1.2
--- src/backend/optimizer/plan/planner.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 41,46 ****
--- 41,52 ----
  #include "utils/lsyscache.h"
  #include "utils/syscache.h"
  
+ #include "catalog/pg_partition.h"
+ #include "utils/fmgroids.h"
+ #include "catalog/indexing.h"
+ #include "utils/tqual.h"
+ #include "catalog/pg_namespace.h"
+ #include "access/hash.h"
  
  /* GUC parameter */
  double cursor_tuple_fraction = DEFAULT_CURSOR_TUPLE_FRACTION;
***************
*** 96,101 ****
--- 102,440 ----
  									   int *ordNumCols,
  									   AttrNumber **ordColIdx,
  									   Oid **ordOperators);
+ Oid OperatorGet(const char *operatorName,
+             Oid operatorNamespace,
+             Oid leftObjectId,
+             Oid rightObjectId,
+             bool *defined);
+ extern Oid get_relevant_partition(HeapTuple tuple, Relation rel);
+ extern Oid get_relevant_hash_partition(HeapTuple tuple, Relation rel);
+ extern Oid TypenameGetTypid	(const char *typname);
+ extern Node* coerce_to_specific_type(ParseState *pstate,
+ 		Node *  	  node,
+ 		Oid  	  targetTypeId,
+ 		const char *  	  constructName
+ 	)  ;	
+ extern Oid RelnameGetRelid(	const char *relname); 
+ 
+ /*
+  * Evaluate the constraints and fine relevent table to operate on.
+  */
+ Oid
+ get_relevant_hash_partition(HeapTuple tuple, Relation rel) {
+     ScanKeyData skey;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+     Relation    pg_partrel;
+ 	bool		flag;
+ 	StringInfo	str_to_hash = makeStringInfo();
+ 
+    /* Lists to identify partition id to which the row should belong.
+      * irr_part_list - list of oids of irrelevent partitions.
+      * rel_part_list - list may contain irrelevent partition along
+      *                  with relevent partition
+      */
+     List        	*distinct_part_key_list=NULL;
+     List        	*rel_part_list= NULL;
+ 	int				hash_partition_entries = 0;
+ 	unsigned int	hashValue;
+ 
+ 	flag = false;
+ 	resetStringInfo(str_to_hash);	
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+ 		bool			isnull, typbyval;
+ 		int16 			len;
+ 		bool			isVariableLength;
+ 		Oid				typoutput;
+ 		Datum 			attr;
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(pg_part->parttype == PART_HASH)
+ 		{		
+ 			/* Increase the no. of hash partition entries count. */
+ 			hash_partition_entries++;
+ 
+ 			if (!list_member_int(distinct_part_key_list, pg_part->partkey))
+ 			{
+ 				distinct_part_key_list = lappend_int(distinct_part_key_list, pg_part->partkey);
+ 
+ 		        /* Get attribute from tuple */
+ 		        attr      = heap_getattr(tuple, pg_part->partkey, rel->rd_att, &isnull);
+ 
+         		/* Get len and typbyval from pg_type */
+ 	        	get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 
+ 				/* Read the list value */
+ 				getTypeOutputInfo(pg_part->keytype, &typoutput, &isVariableLength);
+ 				appendStringInfo(str_to_hash, DatumGetCString(OidFunctionCall1(typoutput, attr)));
+ 			}
+ 		}
+ 	}
+ 
+ 	hashValue = DatumGetUInt32(hash_any((unsigned char *)str_to_hash->data, strlen(str_to_hash->data))) % 
+ 				(int)(hash_partition_entries / distinct_part_key_list->length);
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         bool            isnull;
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_HASH)
+         {
+ 	        /* Get min attribute from catalog */
+     	    Datum datumDashValue = heap_getattr (pg_parttup,Anum_pg_partition_hashval, 
+                                         pg_partrel->rd_att, &isnull);
+ 
+ 			if(datumDashValue == hashValue)
+ 			{
+ 				if (!list_member_oid(rel_part_list, pg_part->partrelid))		
+ 				{
+ 					rel_part_list = lappend_oid(rel_part_list, pg_part->partrelid);
+ 
+ 					if(list_length(rel_part_list) > 1)
+ 						elog(ERROR, "Found more than one matching partitions.");
+ 				}
+ 			}
+ 		}
+ 	}
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ 
+ 	return (Oid)rel_part_list->head->data.oid_value;
+ }
+ 
+ #if 0
+ /*
+  * get CString of Datum.
+  */
+ static char*
+ DisplayDatum(Datum datum, Oid type)
+ {
+     Oid     typeOut;
+     bool    isVariableLength;
+ 
+     getTypeOutputInfo(type, &typeOut, &isVariableLength);
+     return (DatumGetCString(OidFunctionCall1(typeOut, datum)));
+ }
+ #endif
+ 
+ /* Function to get partiton id for a tuple inserted on master relation.
+  * Uses pg_partition catalog lookup to verify boundry condition.
+  * Each entry in catalog corresponds to constraint on single column.
+  */
+ 
+ Oid
+ get_relevant_partition(HeapTuple tuple, Relation rel) {
+     ScanKeyData skey;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+     Relation    pg_partrel;
+ 
+    /* Lists to identify partition id to which the row should belong.
+      * irr_part_list - list of oids of irrelevent partitions.
+      * rel_part_list - list may contain irrelevent partition along
+      *                  with relevent partition
+      */
+     List        *irr_part_list=NULL;
+     List        *rel_part_list= NULL;
+     ListCell    *part_oid;
+ 	Oid 		result = 0 ;
+ 	bool		isSingleAttrPartition;
+ 	int			partitionCount;
+ 	Datum 		values[Natts_pg_partition];
+ 	char  		nulls [Natts_pg_partition];	
+     bool    	isnull, isdef, gte_min, lt_max, typbyval;
+     int16   	len;
+     Datum   	short_datum;
+     Oid     	typoutput;
+     bool    	isVariableLength;
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+ 	isSingleAttrPartition = true;
+ 	partitionCount = 0;
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+ 		Datum attr;
+ 		RegProcedure oper_proc, oper_proc2;
+ 		Oid min_oper, max_oper;
+ 		Datum part_attr;
+ 
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		heap_deformtuple(pg_parttup, pg_partrel->rd_att, values, nulls);
+ 
+ 		if(pg_part->keyorder > 1)
+ 		{
+ 			isSingleAttrPartition = false;
+ 		}
+ 
+ 		/* Increase the partition count */
+ 		if(pg_part->keyorder == 1)
+ 			partitionCount++;
+ 
+ 		/* Get attribute from tuple */
+ 		attr      = heap_getattr(tuple, pg_part->partkey, rel->rd_att,&isnull);
+ 
+ 		getTypeOutputInfo(pg_part->keytype, &typoutput, &isVariableLength);
+ 
+ 		/* Get len and typbyval from pg_type */
+ 		get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 
+ 		if(nulls[Anum_pg_partition_minval-1] == 'n')
+ 		{
+ 			gte_min = true;
+ 		}
+ 		else
+ 		{
+ 			/* Get min attribute from catalog */
+ 			part_attr = heap_getattr (pg_parttup,Anum_pg_partition_minval,
+ 											pg_partrel->rd_att,&isnull);
+ 
+ 			/* Three cases a. datatypes with typbyval true and fix length.
+ 			 * b. datatypes with byval false and fix length.
+ 			 * c. extendible datatypes where length -1.
+ 			 */
+ 			if ( typbyval )
+ 			{
+ 				short_datum = 0;
+ 				memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+ 				part_attr = short_datum;
+ 			}
+ 			else if (len != -1)
+ 			{
+ 				part_attr = (Datum)VARDATA_ANY(part_attr);
+ 			}	
+ 
+ 			/* Evaluate whether tuple value satisfies partition key cnstraint */
+ 			min_oper = OperatorGet(">=", PG_CATALOG_NAMESPACE , pg_part->keytype,
+ 											pg_part->keytype, &isdef);
+ 			oper_proc = get_opcode(min_oper);
+ 			gte_min = DatumGetBool(OidFunctionCall2(oper_proc, attr, part_attr));
+ 		}
+ 
+ 		if(nulls[Anum_pg_partition_maxval-1] == 'n')
+ 		{
+ 			lt_max = true;
+ 		}
+ 		else
+ 		{
+ 			/* Similar steps for max attribute of catalog */
+ 			part_attr = heap_getattr (pg_parttup,Anum_pg_partition_maxval,
+ 											pg_partrel->rd_att,&isnull);
+ 			if ( typbyval )
+ 			{
+ 				short_datum = 0;
+ 				memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+ 				part_attr = short_datum;
+ 			}
+ 			else if (len != -1 )
+ 			{
+ 				part_attr = (Datum)VARDATA_ANY(part_attr);
+ 			}
+ 
+ 			max_oper = OperatorGet("<", PG_CATALOG_NAMESPACE , pg_part->keytype,
+ 									pg_part->keytype, &isdef);
+ 			oper_proc2 = get_opcode(max_oper);
+ 			lt_max = DatumGetBool(OidFunctionCall2(oper_proc2,attr,part_attr));
+ 		}
+ 
+ 		/* Create relevent and  irrelevent partition lists */
+ 		if ( gte_min & lt_max )
+ 		{
+ 			if((isSingleAttrPartition == true) && (partitionCount > 1))
+ 			{
+ 				systable_endscan(pg_partscan);
+ 				heap_close(pg_partrel, RowExclusiveLock);	
+ 				return pg_part->partrelid;			
+ 			}
+ 
+ 			if ( !list_member_oid(irr_part_list, pg_part->partrelid) )
+ 				rel_part_list = lappend_oid(rel_part_list, pg_part->partrelid);
+ 		}
+ 		else
+ 		{
+ 			if(!((isSingleAttrPartition == true) && (partitionCount > 1)))
+ 			{
+ 				irr_part_list = lappend_oid(irr_part_list, (pg_part->partrelid));
+ 			}
+ 		}
+     }
+ 
+     /* Scan through lists to get partition oid to which the tuple is to be inserted */
+ 	if(rel_part_list == NULL)
+ 	{
+ 		StringInfo 	tableName = makeStringInfo();
+ 	    /* Get overflow partition. */
+ 	    appendStringInfo(tableName, "of_%s_%u", RelationGetRelationName(rel), RelationGetRelid(rel));
+ 	    result = RelnameGetRelid(tableName->data);
+ 	}
+ 	else
+ 	{
+    		foreach(part_oid, rel_part_list)
+ 	    {
+     	    if ( list_member_oid(irr_part_list, part_oid->data.oid_value) )
+ 			{
+ 				StringInfo 	tableName = makeStringInfo();
+ 			    /* Get overflow partition. */
+ 			    appendStringInfo(tableName, "of_%s_%u", RelationGetRelationName(rel), RelationGetRelid(rel));
+ 			    result = RelnameGetRelid(tableName->data);
+ 			}
+ 			else
+ 			{
+ 				result = (Oid)part_oid->data.oid_value;
+ 			}
+ 	    }
+ 	}
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ 
+ 	return result;
+ }
+ 
  
  
  /*****************************************************************************
Index: src/backend/optimizer/util/plancat.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/optimizer/util/plancat.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/optimizer/util/plancat.c	19 May 2009 06:59:32 -0000	1.1.1.2
--- src/backend/optimizer/util/plancat.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 37,42 ****
--- 37,47 ----
  #include "utils/lsyscache.h"
  #include "utils/rel.h"
  #include "utils/snapmgr.h"
+ #include "catalog/pg_inherits.h"
+ #include "catalog/pg_inherits_fn.h"
+ #include "utils/fmgroids.h"
+ #include "utils/tqual.h"
+ #include "utils/syscache.h"
  
  
  /* GUC parameter */
***************
*** 50,55 ****
--- 55,61 ----
  						 Oid relationObjectId, RelOptInfo *rel,
  						 bool include_notnull);
  
+ Oid find_inheritance_parent(Oid inhrelid);
  
  /*
   * get_relation_info -
***************
*** 845,850 ****
--- 851,886 ----
  
  	return (Selectivity) result;
  }
+ 
+ /* Return parent oid for child table.
+  * Useful to find out parent in case of cross partition updates.
+  */
+ 
+ Oid
+ find_inheritance_parent(Oid inhrelid)
+ {
+     Relation    relation;
+     HeapScanDesc scan;
+     HeapTuple   inheritsTuple;
+     Oid         inhparent;
+     ScanKeyData key[1];
+ 
+ 
+     ScanKeyInit(&key[0],
+                 Anum_pg_inherits_inhrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(inhrelid));
+     relation = heap_open(InheritsRelationId, AccessShareLock);
+     scan = heap_beginscan(relation, SnapshotNow, 1, key);
+     while ((inheritsTuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
+     {
+         inhparent = ((Form_pg_inherits)GETSTRUCT(inheritsTuple))->inhparent;
+     }
+     heap_endscan(scan);
+     heap_close(relation, AccessShareLock);
+     return inhparent;
+ }
+ 
  
  /*
   * has_unique_index
